//
//  ThirdViewController.swift
//  This controller focuses on help/about information.
//  Fog of Text
//
//  Created by Joe Mccormack on 7/5/20.
//  Copyright © 2020 Joe Mccormack. All rights reserved.
//

import UIKit
/* Google Ads - Importation */
/*
import GoogleMobileAds
*/

class ThirdViewController: UIViewController {
    let Obj_ConfigClass = ConfigClass()
    
    /* Google Ads - Initialization for this controller */
    /*
    @IBOutlet weak var bannerView: GADBannerView!
    */
    @IBOutlet weak var bannerView: UILabel!
    
    /* Text boxes that text files in Resources are loaded in */
    @IBOutlet weak var aboutTextBox: UITextView!
    @IBOutlet weak var helpFaqTextBox: UITextView!
    
    /* If an error occurs, alert the user. */
    func foundError(msg: String) {
        /* Show alert message */
        let alertController = UIAlertController(title: "Error Found", message: msg, preferredStyle: .alert)
        let defaultAction = UIAlertAction(title: "Close", style: .default, handler: nil)
        alertController.addAction(defaultAction)
        present(alertController, animated: true, completion: nil)
    }
    
    /* Terms and Conditions acceptance check */
    func didAcceptToc() -> Bool {
        var acceptedResult: Bool = false
        /* Reference to configuration data */
        var Obj_ConfigClass = ConfigClass()
        /* Check to see if TOC was accepted */
        Obj_ConfigClass.recallToc()
        /* TOC was accepted by the user */
        if Obj_ConfigClass.tocAccepted == true {
            acceptedResult = true
        }
        return acceptedResult
    }
    
    /* Special handling to show alerts because they cannot be triggered from viewDidLoad().  Handy. */
    override func viewDidAppear(_ animated: Bool) {
        if didAcceptToc() == true {
            /* Catch Resources file loading errors */
            var errResults: String = ""
            
            /* Load the text content for the About section of the controller */
            let aboutFilename: String = "about"
            if let abouturl = Bundle.main.url(forResource: aboutFilename, withExtension: "txt") {
                do {
                    /* Load Data */
                    let aboutData = try String(contentsOf: abouturl)
                    /* Dump data into aboutTextBox */
                    aboutTextBox.text = aboutData
                }
                catch {
                    errResults = "Content for the about section could not be loaded: \(error.localizedDescription).  "
                }
            }
            
            /* Load the text content for the Help-FAQ section of the controller */
            let helpfaqFilename: String = "help-faq"
            if let helpfaqurl = Bundle.main.url(forResource: helpfaqFilename, withExtension: "txt") {
                do {
                    /* Load Data */
                    let helpfaqData = try String(contentsOf: helpfaqurl)
                    /* Dump data into helpFaqTextBox */
                    helpFaqTextBox.text = helpfaqData
                }
                catch {
                    errResults += "Content for the help-faq section could not be loaded: \(error.localizedDescription).  "
                }
            }

            /* If an error occurred attempting to load the text files in the Resources folder, show alert message. */
            if errResults.count > 0 {
                errResults += "This mobile application may not have installed correctly on your device.  Please try closing and re-starting the app.  If that does not work you may need to re-install the app if the problem persists."
                foundError(msg: errResults)
            }
        }
    }
    
    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view.
        
        /* Google Ads - Configuration and invocation for this controller; currently bypassed with a placeholder for future use */
        /*
        Obj_ConfigClass.hasPurchasedAdRemoval()
        if (Obj_ConfigClass.showAds == true) {
            /* Show Ads */
            bannerView.adSize = kGADAdSizeBanner
            bannerView.adUnitID = Obj_ConfigClass.googleBannerAdUnitID
            bannerView.rootViewController = self
            bannerView.load(GADRequest())
            /* Uncomment for troubleshooting banner ad retrieval issues */
            //bannerView.delegate = self
        }
        */

    }
}
 
/* Google Ads - Delegate primarily for troubleshooting */
/*
extension ThirdViewController: GADBannerViewDelegate {
    func adViewDidReceiveAd(_ bannerView: GADBannerView) {
        print("Received Ad")
    }
    func adView(_ bannerView: GADBannerView, didFailToReceiveAdWithError error: GADRequestError) {
        print("Banner Retrival Error \(error)")
    }
}
*/
